/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ץȥʡ
 * (      )     : 2004/06/13
 *      񤤤  : 12 Z80FPU5k
 * (___)__)   Ď؎ˎގ: ؤ41
 *            MogillaescapeϲѤʤΤǤǼʡ
 *            
 * </pre>
 */

function moz2ch2chKakiko () {
    this.base = moz2chKakiko;
	this.base();
}

moz2ch2chKakiko.prototype = new moz2chKakiko();

const filePerm = 0644;

///////////////////////
// extends moz2chKakiko

moz2ch2chKakiko.prototype.additionalCookie = null;
moz2ch2chKakiko.prototype.baseCookie = null;

moz2ch2chKakiko.prototype.setOtherHeaders =
function () {
	if (this.baseCookie == null)
		this.loadBaseCookie();
	if (this.additionalCookie == null)
		this.loadAdditionalCookie();
	var cookie = this.baseCookie+ this.additionalCookie;
	this.channel.setRequestHeader("Cookie", cookie, true);
	if(this.target.itaID == "be.2ch.net"){
	    this.channel.setRequestHeader("Accept-Charset","euc-jp", true);
	}else{
	    this.channel.setRequestHeader("Accept-Charset","Shift_JIS", true);
	}
};

moz2ch2chKakiko.prototype.loadAdditionalCookie =
function () {
	var f = new File(moz2ch.sureView.data.getMoz2chDir());
	var fname = "cookie.txt";
	f.append(fname);
	if(f.exists()){
		f.open("r");
		var dat = f.read();
		f.close();
		this.additionalCookie = dat;
	}
};

moz2ch2chKakiko.prototype.loadBaseCookie =
function () {
	var f = new File(moz2ch.sureView.data.getMoz2chDir());
	var fname = "cookie_base.txt";
	f.append(fname);
	if(f.exists()){
		f.open("r");
		var dat = f.read();
		f.close();
		this.baseCookie = dat;
	}
};

moz2ch2chKakiko.prototype.saveAdditionalCookie =
function () {
	var f = new File(moz2ch.sureView.data.getMoz2chDir());
	var fname = "cookie.txt";
	f.append(fname);
	f.open("w",filePerm);
	f.write(this.additionalCookie);
	f.close();
};

moz2ch2chKakiko.prototype.saveBaseCookie =
function () {
	var f = new File(moz2ch.sureView.data.getMoz2chDir());
	var fname = "cookie_base.txt";
	f.append(fname);
	f.open("w",filePerm);
	f.write(this.baseCookie);
	f.close();
};

moz2ch2chKakiko.prototype.getEscape =
function () {
	if(this.target.itaID == "be.2ch.net"){
		return moz2chEscape("euc-jp",this.submit);
	}else{
		return moz2chEscape("Shift_JIS",this.submit);
	}
};

moz2ch2chKakiko.prototype.makePostData =
function (sub) {
    if(this.KAKIKO){
        var kakikoDate = this.target.lastAccess;
        if( ! kakikoDate ) {
		    kakikoDate = new Date(Date.parse(this.target.ita.getAttribute(this.target.sureId, "lastModified")));
	    }
	    if( ! kakikoDate ) {
		    kakikoDate = new Date();
	    }
    }

	if(this.target.itaID == "be.2ch.net"){
		var postData = "submit=" + sub + 
		"&FROM=" + moz2chEscape("euc-jp",this.kakikoInfo.name) +
		"&mail=" + moz2chEscape("euc-jp",this.kakikoInfo.mail) +
		"&MESSAGE=" + moz2chEscape("euc-jp",this.kakikoInfo.msg) +
		"&bbs=" + this.target.itaID + 
		(this.SURETATE ? "&subject=" + moz2chEscape("euc-jp",this.kakikoInfo.subject) :
                            "&key=" + this.target.datID) +
		"&time=" + (this.SURETATE ? 1 : Math.ceil((kakikoDate.getTime())/1000)) +
		(this.SURETATE ? "" : "");
		postData = moz2chCharset.uni2euc(postData);
	}else{
		var postData = "submit=" + sub + 
		"&FROM=" + moz2chEscape("Shift_JIS",this.kakikoInfo.name) +
		"&mail=" + moz2chEscape("Shift_JIS",this.kakikoInfo.mail) +
		"&MESSAGE=" + moz2chEscape("Shift_JIS",this.kakikoInfo.msg) +
		"&bbs=" + this.target.itaID + 
		(this.SURETATE ? "&subject=" + moz2chEscape("Shift_JIS",this.kakikoInfo.subject) :
                            "&key=" + this.target.datID) +
		"&time=" + (this.SURETATE ? 1 : Math.ceil((kakikoDate.getTime())/1000)) +
		(this.SURETATE ? "" : "");
		postData = moz2chCharset.uni2sjis(postData);
	}

	return postData;
};

moz2ch2chKakiko.prototype.setChannel =
function (uChannel) {
    if(this.target.itaID == "be.2ch.net"){
		uChannel.setUploadStream(this.uiStream, "text/plain; charset=euc-jp", -1);
    }else{
		uChannel.setUploadStream(this.uiStream, "text/plain; charset=Shift_JIS", -1);
    }

	return uChannel;
};

moz2ch2chKakiko.prototype.parse = 
function () {
	try{
		//var reg_ip = new RegExp('',"g");
		//<input type=hidden name="suka" value="pontan"><br>
		var cookie_def = this.channel.getResponseHeader("Set-Cookie");
		var cookie_d1 = cookie_def.match(/HAP=[a-zA-Z0-9]+/, "g");
		var cookie_d2 = cookie_def.match(/PON=[a-zA-Z0-9.\-_]+/, "g");
		if (cookie_d1 && cookie_d2){
			var cookie = cookie_d1 + ";" + cookie_d2 + ";";
			if (this.baseCookie != cookie){
				this.baseCookie = cookie;
				this.saveBaseCookie();
			}
		}
		var cookies = this.htmlRes.match(/<input\stype=hidden\sname=\"([A-Za-z]+)\"\svalue=\"([A-Za-z]+)\"><br>/, "g");
		if (cookies){
			cookie = cookies[1] + "=" + cookies[2];
			if (this.additionalCookie != cookie){
				this.additionalCookie = cookie;
				this.saveAdditionalCookie();
			}
		}
		this.htmlTitle = String(this.htmlRes.match(/<title>\S+<\/title>/)); //title򎹎ގ
	    this.htmlTitle = String(this.htmlTitle.replace(/<\/*title>/g, "")); 
	    this.tag2ch = String(this.htmlRes.match(/<!-- 2ch_X:\w+ -->/));     //2ch򎹎ގ
	    this.msg = String(this.htmlRes.replace(/<br\/*>/g, "\n"));          //Ҏޤ򎹎ގ
	    this.msg = String(this.msg.replace(/<\/*.+?>/g, ""));
        this.msg = String(this.msg.replace(/\n{3}/g, "\n"));
	}catch(e){
        moz2ch.debug(e);
    }
};
