/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   2chĥĥ꡼饹ʡ
 * (      )     : 2004/05/29
 *      񤤤  : ؤ41
 * (___)__)   Ď؎ˎގ: 
 *                        ʬ䤷
 *            
 * </pre>
 */

function moz2chJbbsItaTree(title, url) {
    this.base = moz2chItaTree;
    this.base(title, url);
    if(!this.url)
	this.url = "http://jbbs.livedoor.jp"
    this.getTitle =  function () {
        return moz2chCharset.euc2uni("JBBS Livedoor");
    };

    this.bbsId = "jbbs";
    this.rdfRootURI = "http://jbbs.livedoor.jp/";

    // BBSǥ쥯ȥꥲȡ
    var dir = new Dir(this.getBBSDir());

    dir.append(kMoz2chRDFName);
    file = kIOService.newFileURI(dir.nsIFile).spec;

    // ǡ򥻥ơ
    var ds = kRDFService.GetDataSourceBlocking(file);
    this.datasource = ds;

    // RDFκǤäȤ
    var res = kRDFService.GetResource(this.rdfRootURI); //͡ߥ󥰤Ѥ
    this.rdfRoot = kRDFContainerUtils.MakeSeq(this.datasource, res);

    this.changeDat = new Array();
    this.getsabaDat(kMoz2chJBBSSabaFileName);
}

///////////
// 
moz2chJbbsItaTree.prototype.itaTreeLeaf = "";

const kMoz2chJBBSSabaFileName = "sabadatJBBS.txt";

/////////////////////////
// extends moz2chTreeData
moz2chJbbsItaTree.prototype = new moz2chItaTree();

/**
 * bbsmenu.htmlѡ
 * @return true
 */

moz2chJbbsItaTree.prototype.get =
function () {
    this.data = "";
    this.clear();
    var rv = this.parse();
    this.loaded();

    if (rv && this.data.length > 0) {
	// if parse succeeded, save the data.
	var f = new File(this.getLogPath());
	f.open("w", kMoz2chDataFilePerm);
	f.write(this.data);
	f.close();
    }
    moz2ch.setBusy(false);
};

moz2chJbbsItaTree.prototype.dataConvert =
function () {
	return "";
};

moz2chJbbsItaTree.prototype.mainParse =
function (data) {
    // external ita tree file
    this.readOtherBrd();

    this.datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();

    var text = this.changeDat.join("\r\n");
    var f = new File(this.getMoz2chDir());
    f.append(kMoz2chJBBSSabaFileName);
    f.open("w", kMoz2chDataFilePerm);
    f.write(moz2chCharset.uni2sjis(text));
    f.close();
};

/**
 * Ĥɤ߹ࡣ
 * Ĥ<profile>/Moz2ch/bbs/jbbs/jbbs.brd2channel.brdǳǼ롣
 */
moz2chJbbsItaTree.prototype.itaTreeOtherBrd = "jbbs.brd";
moz2chJbbsItaTree.prototype.checkExistOtherBrd =
function () {
    var f = new Dir(this.getBBSDir());
    f.append(this.itaTreeOtherBrd);
    var path = f.path;

    var f = new File(path);

    var brd;
    if (!f.exists()) {
        brd = "1\r\nJBBS Livedoor\t0\r\n\t";
        f.open("w", 0700);
        f.write(moz2chCharset.uni2sjis(brd));
        f.close();
    } else {
        f.open("r");
        brd = moz2chCharset.sjis2uni(f.read());
        f.close();
    }
	return brd;
};

moz2chJbbsItaTree.prototype.parseOtherBrd =
function (brd) {
	var i;
    var category = null;
    for (i = 1; i < brd.length; i++) {
        var tokens = brd[i].split("\t");
        if (tokens.length >= 4 && category) {
            // this is ita
            var url = "http://jbbs.livedoor.jp/" + tokens[1] + "/" + tokens[2] + "/";
	    tokens[3] = tokens[3].replace(/\s/g,"");
	    this.addIta(category, tokens[3], url);
	    this.changeDat.push(url + " " + tokens[3]);
        } else if (tokens.length >= 2) {
            // this is category
            category = this.addCategory(tokens[0]);
            // category.open = (1 == tokens[0]);
        }
    }
};
