/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ޤ££ĥĥ꡼饹ʡ
 * (      )     : 2004/05/29
 *      񤤤  : ؤ41
 * (___)__)   Ď؎ˎގ: 
 *                        
 *            
 * </pre>
 */

function moz2chMachiItaTree(title, url) {
    this.base = moz2chItaTree;
    this.base(title, url);
    if(!this.url)
	this.url = "http://www.machi.to/";
    this.getTitle =  function () {
        return moz2chCharset.euc2uni("ޤ££");
    };

    this.bbsId = "machi";
    this.rdfRootURI = "http://www.machi.to/";

    // BBSǥ쥯ȥꥲȡ
    var dir = new Dir(this.getBBSDir());

    dir.append(kMoz2chRDFName);
    file = kIOService.newFileURI(dir.nsIFile).spec;

    // ǡ򥻥ơ
    var ds = kRDFService.GetDataSourceBlocking(file); 
    this.datasource = ds;
   
    // RDFκǤäȤ
    var res = kRDFService.GetResource(this.rdfRootURI); //͡ߥ󥰤Ѥ
    this.rdfRoot = kRDFContainerUtils.MakeSeq(this.datasource, res);

    this.changeDat = new Array();
    this.getsabaDat(kMoz2chMachiSabaFileName);
}


///////////
// 
moz2chMachiItaTree.prototype.itaTreeLeaf = "index.html";

const kMoz2chMachiSabaFileName = "sabadatMachi.txt";

/////////////////////////
// extends moz2chTreeData
moz2chMachiItaTree.prototype = new moz2chItaTree();

/**
 * index.htmlѡ
 * @return true
 */
moz2chMachiItaTree.prototype.dataConvert =
function () {
    var data = moz2chCharset.sjis2uni(this.data);

	return data;
};

moz2chMachiItaTree.prototype.mainParse =
function (data) {
	var blocks = data.split(/<table/gi);
    var catListRe= new RegExp(moz2chCharset.euc2uni("ϰ̥ƥ꡼"));
    var urlRe = /\"(http:\/\/.*\/)\">?(.*?)<\/a>/;

    for ( var i=0; i<blocks.length; i++ ) {
        if ( catListRe.test( blocks[i] )) {
            var subblks = blocks[i].split(/<a href/gi);
            var category = this.addCategory(moz2chCharset.euc2uni("ޤ££"));
            for ( var j=0; j<subblks.length; j++ ) {
                var ret = urlRe.exec( subblks[j] );
                if ( ret ) {
                    this.addIta(category, ret[2], ret[1]);
					this.changeDat.push(ret[1] + " " + ret[2])
                } 
            }
            this.addIta(category, moz2chCharset.euc2uni("ļ"), "http://www.machi.to/tawara/");
			this.changeDat.push("http://www.machi.to/tawara/ " + moz2chCharset.euc2uni("ļ"))
            break;
        }
    }

    this.datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();

    var text = this.changeDat.join("\r\n");
    var f = new File(this.getMoz2chDir());
    f.append(kMoz2chMachiSabaFileName);
    f.open("w", kMoz2chDataFilePerm);
    f.write(moz2chCharset.uni2sjis(text));
    f.close();
};

/**
 * ƥɲä
 *
 * @param aTitle ƥΥȥ
 * @return ɲä줿ƥnsIRDFContainer
 */
moz2chMachiItaTree.prototype.addCategory =
function (aTitle) {
    var res = kRDFService.GetResource(
            "uri:category" + this.rdfRoot.GetCount()); 
    var category = kRDFContainerUtils.MakeSeq(this.datasource, res);
    this.datasource.Assert(res, kMoz2chItaTreeTitleRes,
            kRDFService.GetLiteral(aTitle), true);

    this.rdfRoot.AppendElement(res);
    return category;
};

/**
 * Ĥɲä
 * 
 * @param aCategory ƥnsIRDFContainer
 * @param aTitle    ĤΥȥ
 * @param aUrl      ĤURL
 * @param aType     Ĥμ(ά"2ch")
 */
moz2chMachiItaTree.prototype.addIta =
function (aCategory, aTitle, aUrl, aType) {
    if (!aType)
        aType = "2ch";

    var res = kRDFService.GetAnonymousResource();

    this.datasource.Assert(res, kMoz2chItaTreeTitleRes,
            kRDFService.GetLiteral(aTitle), true);
    this.datasource.Assert(res, kMoz2chItaTreeURLRes, 
            kRDFService.GetLiteral(aUrl), true);
    this.datasource.Assert(res, kMoz2chItaTreeTypeRes,
            kRDFService.GetLiteral(aType), true);
    aCategory.AppendElement(res);
};
