/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ޤBBSΥΥ饹ʡ
 * (	  )     : 2005/01/14
 *      񤤤  : ؤ41
 * (___)__)   Ď؎ˎގ: (ߢώ)(ߢώ) tRZ80FPU5k
 *                      : 
 *                      : 
 *            moz2chSureȶ̤δؿ򥳥ȥȥʡ
 *	      
 * </pre>
 */

function moz2chMachiSure(ita, title, url) {
	this.base = moz2chSure;
	this.base(ita, title, url);

	this.bbsId = "machi";
	var a = this.url.split("/");
	//http://kanto.machi.to/bbs/read.pl?BBS=kana&KEY=1090407374
	var b = a.pop();
	b = b.replace(/[?=&]/g, "/" );
	b = b.split("/");
	this.datID = b.slice(4,5);
	this.itaID = b.slice(2,3);
	this.sabaID = a.slice(2, a.length - 1).join("/");
	
	this.sureAcq = this.ita.getAttribute(this.datID + ".dat", "sureAcq");
	this.sureClassName = "moz2chMachiSure";
}

/////////////////////
// extends moz2chData
moz2chMachiSure.prototype = new moz2chSure();

moz2chMachiSure.prototype.sureId getter = 
function () {
	return this.datID + ".dat";
};

/////////////////////////////////
// title/log/download information

moz2chMachiSure.prototype.getDataURL =
function () {
	return "http://" + this.sabaID + "/bbs/read.pl?BBS=" + this.itaID + "&KEY=" + this.datID;
};

/////////////////
// parse the data

moz2chMachiSure.prototype.preParse =
function() {
	var data = moz2chCharset.sjis2uni(this.data);
	this.data = "";
	var blocks = data.split(/\n<dt>/);
	var title, num;
	var rv;
	var cntres=0;

	title = moz2chCharset.euc2uni("ȥ̵̾");
	for( var i=0; i<blocks.length; i++ ) {
		rv = blocks[i].match("<title>(.*?)<\/title>");
		if ( rv ) {
			title = rv[1];
		}
		
		rv = blocks[i].match(moz2chCharset.euc2uni("^([0-9]{1,4}) ̾"));
		if ( rv ) {
			blocks[i] = blocks[i].replace(/\n/g,"");
			cntres++;
			num = rv[1];
			for ( var j = cntres ; j < num ; j++ ) {
				this.data += moz2chCharset.euc2uni(" ܡ<>ܡ<>ܡ<>ܡ<>\n");
			}
			cntres=num;

			var mail = blocks[i].match("<a href=\"mailto:(.*?)\">");
			mail = mail ? mail[1] : "";
			var name = blocks[i].match("<b>(.*?)<\/b>", "i");
			name = name ? name[1] : "";
			var date = blocks[i].match(moz2chCharset.euc2uni("") + "(.*?)<br>");
			date = date ? date[1] : "";
			var msg = blocks[i].match("<dd>(.*)");
			msg = msg ? msg[1] : "";
			msg = msg.replace(/<a href.*>(.*?)<\/a>/g, "$1");
			

			this.data += name + "<>" + mail + "<>" + date + "<>" + msg + "<>";
			if ( i == 1 ) {
				this.data += title;
			}
			//Ĥ˥ߤĤΤǴʰ׽ʤorz
			this.data += "\n";
		}
	this.data = this.data.split("<table ")[0];
	}

	this.data = moz2chCharset.uni2sjis(this.data);
}

moz2chMachiSure.prototype.res200 =
function () {
	this.preParse();

	return 0;
};

moz2chMachiSure.prototype.res304 =
function () {
	moz2ch.status();
	moz2ch.status(moz2ch.getString("nonchange"));
};

moz2chMachiSure.prototype.saveLastModified =
function () {
};
