/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ǡӥ塼饹ʡ
 * (      )     : 2004/06/15
 *      񤤤  : ˼⤸顼
 * (___)__)   ȥӥݥ: Z80FPU5kؤ41桢
 *            ĥ꡼ǡӥ塼ӥ塼饹
 *            ѡ饹ˤʤʡ
 *            
 *
 * subclassϤĤŬ˼
 *    String elementId;
 * </pre>
 */

function moz2chDataView() {
}

moz2chDataView.prototype = {
    // NS_BINDING_ABORTED =
    //     (NS_ERROR_SEVERITY_ERROR << 31) |
    //     ((NS_ERROR_MODULE_NETWORK + NS_ERROR_MODULE_BASE_OFFSET) << 16) |
    //     2
    NS_BINDING_ABORTED: (1 << 31) | ((6 + 0x45) << 16) | 2,
    data: null,     // moz2chData
    element: null,  // XUL element
    elementId: "",  // XUL element id

    mousex: null,
    mousey: null,
    
    // initialize view
    init: function () {
        this.element = document.getElementById(this.elementId);
        this.mousex = 0;
        this.mousey = 0;
    },

    // load, reload, stop, unload data
    load: function (data) {
        // if loading, stop it
        this.stop();
        this.unload();

        if ( data ) {
            this.data = data;
        }
 
        moz2ch.setBusy(true);
        moz2ch.setCurrent(this);
        var rv = this.data.readLog();
        moz2ch.status(moz2ch.getString("loadlog"));
        moz2ch.debug("moz2chDataView.load: readLog? " + rv);
        moz2ch.setBusy(false);
	moz2ch.status(moz2ch.getString("loadedlog"));
        return rv;
    },
    reload: function (data) {
		try{
		this.stop();
        this.unload();

        if ( data ) {
            this.data = data;
        }
        moz2ch.setBusy(true);
        moz2ch.setCurrent(this);
        this.data.get();
        moz2ch.setBusy(false);
	}catch(e){ moz2ch.debug(e); }
    },
    stop: function () {
        if (this.data && this.data.channel && this.data.channel.isPending()) {
            moz2ch.debug("moz2chDataView.stop: stop loading data " + this.data.title);
            this.data.channel.cancel(Components.interfaces.nsIRequest.NS_BINDING_ABORTED);
            moz2ch.setBusy(false);
	    this.data.data = this.data.oldData;
	    this.data.oldChannel = this.data.channel;
	    this.data.channel = null;
	    this.data.stopFlag = 1;
        }
    },
    unload: function () {
        if (this.data) {
            // save the data
           this.data.unload();
        }
    },
    logDelete: function () {
        if (this.data)
            this.data.deleteLog();
    },
    
    // clear view
    clear: function () {},

    // update view-status ( for reserved )
    update: function () {}, 
    // Add Tab if a sub-class of dataView needs (for reserved)    
    addTab: function () {},
    // find method (for reserved) 
    find: function () {}, 
    
    //////////////////////////////////
    // to implement nsITreeView getter
    // without hack.
    get rowCount() {
        return this.getRowCount();
    },
};

