/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ĤΥ饹ʡ
 * (      )     : 2004/11/13
 *      񤤤  : ˼⤸顼
 * (___)__)   ȥӥݥ:(ϡ)(ϡ) tRZ80FPU5k
 * (___)__)             : ؤ41
 *                      : 
 *            Х᥽åɤĥ
 *            
 * </pre>
 */

const kMoz2chItaLeaf = "subject.txt";

function moz2chIta(itaTree, title, url) {
    this.base = moz2chTreeData;
    this.base(title, url);
}

/////////////////////////
// extends moz2chTreeData
moz2chIta.prototype = new moz2chTreeData();

moz2chIta.prototype.itaId = "";  //abstract ita identifier
moz2chIta.prototype.nowSortType = "sureNum";
moz2chIta.prototype.nowSortDirect = "ascending";
moz2chIta.prototype.itaLeaf = "subject.txt";
moz2chIta.prototype.kakikoView = null;
moz2chIta.prototype.itadata = "";
moz2chIta.prototype.itaoldData = "";
moz2chIta.prototype.itachannel = "";
moz2chIta.prototype.itaoldChannel = "";

moz2chIta.prototype.__defineGetter__("itaId",
function () {
    return itaID;
});

/////////////
// view datas
moz2chIta.prototype.sureRowSet = [];
moz2chIta.prototype.prevRowSet = null;
moz2chIta.prototype.preservedRowSet = [];

/////////////////////////////////
// title/log/download information

moz2chIta.prototype.getTitle =
function () {
    return this.title + moz2ch.separator + this.itaTree.getTitle();
};

moz2chIta.prototype.logPath = null;
moz2chIta.prototype.getLogPath =
function () {
    if (!this.logPath) {
        var logFile = new Dir(this.getBBSDir());
        var sabaIDs = this.sabaID.split("/");
        for (var i = 0; i < sabaIDs.length; i++) {
            logFile.append(sabaIDs[i]);
            if (!logFile.exists())
                logFile.create(kMoz2chDataDirPerm);
        }
        logFile.append(this.itaID);
        if (!logFile.exists())
            logFile.create(kMoz2chDataDirPerm);
        logFile.append(this.itaLeaf);
        this.logPath = logFile.path;
    }
    return this.logPath;
};

moz2chIta.prototype.getDataURL =
function () {
    return this.url + this.itaLeaf;
};

moz2chIta.prototype.getSureURL =
function (dat) {
    var datNum = dat.split(".")[0];
    return "http://" + this.sabaID + "/test/read.cgi/" + this.itaID + "/" + datNum + "/l50";
};

moz2chIta.prototype.reload =
function () {
    this.readIndex();
    this.get();
};

/////////////////
// parse the data

moz2chIta.prototype.dataConvert =
function () {
    var data = moz2chCharset.sjis2uni(this.itadata);

	return data;
};

moz2chIta.prototype.parse =
function () {
    try{
    this.extractNone();
    this.refuge();
    this.clear();

    var data = this.dataConvert();
    var lines = data.split("\n");

    this.mainParse(lines);

    this.merge();
       
    //٥ȥꥹʡFire
    for( var i=0; i<this.dataLoadedListener.length; i++ ) {
        this.dataLoadedListener[i].onDataLoaded( null );
    }

    // parse succeeded
    return true;
    }catch(e){ moz2ch.debug(e); }
};

moz2chIta.prototype.mainParse =
function (lines) {
    var re = /(.+?\.dat|.+?\.cgi)(<>|,)(.*)\(([0-9]{1,4})\)/;
    for (var i = 0; i < lines.length; i++) {
        var ret = re.exec(lines[i]);
        if (ret) {
            ret[3] = ret[3].replace(/quot;/gi, "\"");
            ret[3] = ret[3].replace(/lt;/gi, "<");
            ret[3] = ret[3].replace(/gt;/gi, ">")
            this.addSure(i + 1, ret[3], ret[4], ret[1]);
        }
    }
};

//////////////////////
// previous data merge
// ޤϸŤǡ򤹤롣
moz2chIta.prototype.refuge =
function () {
    this.prevRowSet = this.sureRowSet;
};

// Ťǡ򿷤ǡ˥ޡ
moz2chIta.prototype.merge =
function () {
    var sure_dat = null;
    var sure_ID = null;

    if(moz2ch.sureView.data){
        sure_dat = moz2ch.sureView.data;
	    if(sure_dat && sure_dat.ita.url == this.url)
			sure_ID = sure_dat.datID;
    	else
        	sure_ID = null;
	}else{
		sure_ID = null;
	}

    // dat򥭡ˤưǡ
    var prevRowDic = {};

    for (i = 0; i < this.prevRowSet.length; i++) {
        this.prevRowSet[i].sureNew = null;
        prevRowDic[this.prevRowSet[i].dat] = this.prevRowSet[i];
        if(sure_ID != null){
            if((sure_ID+".dat") == this.prevRowSet[i].dat && sure_dat.ita.getAttribute(sure_ID+".dat", "lastModified")){
                prevRowDic[this.prevRowSet[i].dat].lastModified = sure_dat.ita.getAttribute(sure_ID + ".dat", "lastModified");
                prevRowDic[this.prevRowSet[i].dat].sureRes = sure_dat.ita.getAttribute(sure_ID + ".dat", "sureRes");	    
                prevRowDic[this.prevRowSet[i].dat].sureAttr = "LOADED";
                prevRowDic[this.prevRowSet[i].dat].surePos = sure_dat.ita.getAttribute(sure_ID + ".dat", "surePos");
                prevRowDic[this.prevRowSet[i].dat].sureAcq = sure_dat.ita.getAttribute(sure_ID + ".dat", "sureAcq");
            }
        }
    }

    var prev;
    for (i = 0; i < this.sureRowSet.length; i++) {
        if (prev = prevRowDic[this.sureRowSet[i].dat]) {
            // ǡˤäĥäƤƹܤϺ
            prevRowDic[this.sureRowSet[i].dat] = null;
            this.sureRowSet[i].lastModified = prev.lastModified;
            this.sureRowSet[i].surePos = prev.surePos;
            this.sureRowSet[i].sureAcq = prev.sureAcq;
            if (parseInt(this.sureRowSet[i].sureRes) > parseInt(prev.sureRes)){
                // 쥹Ƥ鿷쥹ͭ
                switch (prev.sureAttr) {
                    case ("NEW"):
                    case ("NONDIS"):
                    case ("NEWRES"):
                        this.sureRowSet[i].sureAttr = "NEWRES";
                        break;
                    case ("LOADED"):
                    case ("LOADED-NONDIS"):
                    case ("LOADED-NEWRES"):
			if(parseInt(this.sureRowSet[i].sureRes) > parseInt(prev.sureAcq)){
			    this.sureRowSet[i].sureAttr = "LOADED-NEWRES";
			}else{
			    this.sureRowSet[i].sureAttr = "LOADED";
			}
                        break;
                }
            } else {
                // 쥹ƤʤäХ䥤
                switch (prev.sureAttr) {
                    case ("NEW"):
                    case ("NONDIS"):
                    case ("NEWRES"):
                        this.sureRowSet[i].sureAttr = "NONDIS";
                        break;
                    case ("LOADED"):
                        this.sureRowSet[i].sureAttr = "LOADED";
                        break;
                    case ("LOADED-NONDIS"):
                    case ("LOADED-NEWRES"):
                        this.sureRowSet[i].sureAttr = "LOADED-NONDIS";
                        break;
                }
            }
        }
    }
    // ޤƼ˻ĤäƤۤdatݤʷϵ
    for (var dat in prevRowDic) {
        if (prevRowDic[dat] != null) {
            prevRowDic[dat].sureNum = this.sureRowSet.length + 1;
	    switch(prevRowDic[dat].sureAttr){
	    case ("NEW"):
	    case ("NONDIS"):
	    case ("NEWRES"):
	    case ("NON-DAT"):
		prevRowDic[dat].sureAttr = "NON-DAT";
		break;
	    default:
		prevRowDic[dat].sureAttr = "LOG-DAT";
	    }
            this.sureRowSet.push(prevRowDic[dat]);
        }
    }

    // 򤷤ŤǡϤ⤦ʤݡ
    this.prevRowSet = null;
};

moz2chIta.prototype.setAttribute = 
function ( dat, key, value ) {
    var rv = 0;
    for (var i = 0; i < this.sureRowSet.length; i++) {
        if (dat == this.sureRowSet[i].dat) {
            this.sureRowSet[i][key] = value;
            return;
        }
    }
    for (var i = 0; i < this.preservedRowSet.length; i++) { 	 
         if (dat == this.preservedRowSet[i].dat) { 	 
             this.preservedRowSet[i][key] = value; 	 
             return; 	 
         } 	 
     }
}

moz2chIta.prototype.getAttribute = 
function ( dat, key ) {
    var rv = 0;
    for (var i = 0; i < this.sureRowSet.length; i++) {
        if (dat == this.sureRowSet[i].dat) {
            return this.sureRowSet[i][key];
        }
    }
     for (var i = 0; i < this.preservedRowSet.length; i++) { 	 
         if (dat == this.preservedRowSet[i].dat) { 	 
             return this.preservedRowSet[i][key]; 	 
         } 	 
     }
}

//ita饹ǻѤ쥯饹
//ȤꤢSuper饹Ϻʤ
function innerSure () {
};

//켱̻Ҥɽ
innerSure.prototype.__defineGetter__("sureId",
function () {
    return this.dat;
});

///////////////////
// read/write index
moz2chIta.prototype.readIndex =
function () {
    try{
    var f = new File(this.getIndexPath());
    if (!f.exists())
        return false;

    f.open("r");
    var index = f.read();
    f.close();
    index = moz2chCharset.sjis2uni(index);
    index = index.split("\r\n");
    this.clear();
    for (var i = 0; i < index.length; i++) {
        var line = index[i].split(",");
        if (line.length < 5)
            break;

        var name = line[1].replace(/\\c/g, ",");
        name = name.replace(/\\\\/g, "\\");
        var lm = line[4].replace(/\\c/g, ",");
        lm = lm.replace(/\\\\/g, "\\");
 
        var row = new innerSure();
        row.sureNum = line[0];
        row.sureName = name;
        row.sureRes = line[2];
        row.dat = line[3];
        row.lastModified =  lm;
        row.sureAttr = (line[5] || "LOADED");
        row.surePos = (line[6] || 0);
        row.sureAcq = (line[7] || 0);
	row.sureNew = null;

        this.sureRowSet.push(row);
    }
       
    // read index succeeded
    return true;
    }catch(e){
	moz2ch.debug(e); 
    }
};

moz2chIta.prototype.writeIndex =
function () {
    try{
    var table = [];
    var tempRowSet;
    tempRowSet = this.sureRowSet.concat(this.preservedRowSet);
    for (var i = 0; i < tempRowSet.length; i++) {
        var name = tempRowSet[i].sureName.replace(/\\/g, "\\\\");
        name = name.replace(/,/g, "\\c");
        var lm = tempRowSet[i].lastModified || "";
        lm = lm.replace(/\\/g, "\\\\");
        lm = lm.replace(/,/g, "\\c");
        table[tempRowSet[i].sureNum -1] = tempRowSet[i].sureNum + "," + name + "," + tempRowSet[i].sureRes
                + "," + tempRowSet[i].dat + "," + lm + "," + tempRowSet[i].sureAttr
                + "," + tempRowSet[i].surePos + "," + tempRowSet[i].sureAcq;
    }

    var index = table.join("\r\n");
    if (index.length > 0) {
        index = moz2chCharset.uni2sjis(index);
       var f = new File(this.getIndexPath());
        f.open("w", 0644);
        f.write(index);
        f.close();
    }
    tempRowSet = null;
    }catch(e){ moz2ch.debug(e); }
};

moz2chIta.prototype.clear =
function () {
    this.sureRowSet = [];
    this.preservedRowSet = [];
};

moz2chIta.prototype.addSure =
function (num, name, res, dat, lastModified) {
    var row = new innerSure();
    row.sureNum = num;
    row.sureName = name;
    row.sureRes = res;
    row.dat = dat;
    row.lastModified = lastModified;
    row.sureAttr = "NEW";
    row.surePos = 0;
    row.sureAcq = 0;
    row.sureNew = null;

    this.sureRowSet.push(row);
};

moz2chIta.prototype.sortSureRowSet = 
function ( key, direct ) {
try {
    var compfunc;

    if (key != this.nowSortType)
        this.nowSortType = key;
    if (direct != this.nowSortDirect)
        this.nowSortDirect = direct;

    switch ( key ) {
    case "sureMark":
        // sureMarksortsureNumʤȤʤ󤫥إʴˤʤΤǡȥåǤ
        if ("ascending" == direct)
            compfunc = function( a, b ) { return ( (a.sureAttr + ("00000" + a.sureNum).substr(-5) < b.sureAttr + ("00000" + b.sureNum).substr(-5))?-1:1 ); }
        else 
            compfunc = function( a, b ) { return ( (b.sureAttr + ("00000" + b.sureNum).substr(-5) < a.sureAttr + ("00000" + a.sureNum).substr(-5))?-1:1 ); }
        break;
    case "sureNum":
        if ("ascending" == direct)
            compfunc = function( a, b ) { return ( a.sureNum - b.sureNum ); }
        else 
            compfunc = function( a, b ) { return ( b.sureNum - a.sureNum ); }
        break;
    case "sureName":
        if ("ascending" == direct) {
            compfunc = function( a, b ) {
                var rv;
                if ( a.sureName < b.sureName) rv = -1;
                else if ( a.sureName > b.sureName ) rv =  1;
                else rv = 0;
                return rv;
            }
        } else {
            compfunc = function( a, b ) {
                var rv;
                if ( a.sureName > b.sureName) rv = -1;
                else if ( a.sureName < b.sureName ) rv =  1;
                else rv = 0;
                return rv;
            }
        }    
        break;
    case "sureRes":
        if ("ascending" == direct)
            compfunc = function( a, b ) { return ( a.sureRes - b.sureRes ); }
        else 
            compfunc = function( a, b ) { return ( b.sureRes - a.sureRes ); }
        break;

    case "sureAcq":
        if ("ascending" == direct)
            compfunc = function( a, b ) { return ( a.sureAcq - b.sureAcq ); }
        else 
            compfunc = function( a, b ) { return ( b.sureAcq - a.sureAcq ); }
        break;
      
    default:
        return;
    }

    this.sureRowSet.sort(compfunc);

}catch(e){
    moz2ch.debug("moz2chIta sort Error: " + e );
}

};

moz2chIta.prototype.extractNone = 
function () {
    this.sureRowSet = this.sureRowSet.concat(this.preservedRowSet);
    this.sortSureRowSet(this.nowSortType, this.nowSortDirect);
    this.preservedRowSet = [];
};

//phrase˥ޥå륿ȥΥSureRowSetƬ˽
moz2chIta.prototype.extractPhrase = 
function ( phrase ) {
try{
    this.extractNone();
    var tmpRowSet = this.sureRowSet;
    this.sureRowSet = [];
    phrase = new RegExp( phrase, "i" );
    for (var i = tmpRowSet.length-1; i >= 0; i-- ) {
        if (phrase.test(tmpRowSet[i].sureName)) {
            this.sureRowSet.unshift(tmpRowSet.splice(i,i+1)[0]);
        } else {
            this.preservedRowSet.unshift(tmpRowSet.splice(i,i+1)[0]);
        }
    }
}catch(e){
    moz2ch.debug(e);
    this.sureRowSet = tmpRowSet;
}
};

//Visitorѥ󤬤褵
moz2chIta.prototype.extractNew = 
function () {
try{
    this.extractNone();
    var tmpRowSet = this.sureRowSet;
    this.sureRowSet = [];
    for (var i = tmpRowSet.length-1; i >= 0; i-- ) {
        if (tmpRowSet[i].sureAttr == "NEW") {
            this.sureRowSet.unshift(tmpRowSet.splice(i,i+1)[0]);
        } else {
            this.preservedRowSet.unshift(tmpRowSet.splice(i,i+1)[0]);
        }
    }
}catch(e){
moz2ch.debug(e);
}
};

moz2chIta.prototype.extractAcquired = 
function () {
try{
    this.extractNone();
    var tmpRowSet = this.sureRowSet;
    this.sureRowSet = [];
    for (var i = tmpRowSet.length-1; i >= 0; i-- ) {
        if (tmpRowSet[i].sureAcq > 0) {
            this.sureRowSet.unshift(tmpRowSet.splice(i,i+1)[0]);
        } else {
            this.preservedRowSet.unshift(tmpRowSet.splice(i,i+1)[0]);
        }
    }
}catch(e){
moz2ch.debug(e);
}
};

moz2chIta.prototype.deleteLogDat =
function(){
    //ޤܤ
    this.extractNone();
    this.refuge();
    this.clear();
    
    //sureAttrNON-DATLOG-DATʤ
    for(var i=0; i<this.prevRowSet.length; i++){
	if((this.prevRowSet[i].sureAttr != "NON-DAT") && 
	   (this.prevRowSet[i].sureAttr != "LOG-DAT")){
	    this.sureRowSet.push(this.prevRowSet[i]);
	}
    }
    this.prevRowSet = null;

    this.writeIndex();
};

moz2chIta.prototype.deleteLogNone =
function(){
    this.extractNone();
    //ޤ
    this.refuge();
    this.clear();

    //sureAttrNON-DATʤ
    for(var i=0; i<this.prevRowSet.length; i++){
	if(this.prevRowSet[i].sureAttr != "NON-DAT"){
	    if(this.prevRowSet[i].sureAttr != "LOG-DAT"){
		this.sureRowSet.push(this.prevRowSet[i]);
	    }else if(parseInt(this.prevRowSet[i].sureAcq) != 0){
		this.sureRowSet.push(this.prevRowSet[i]);
	    }
	}
    }
    this.prevRowSet = null;

    this.writeIndex();
};

moz2chIta.prototype.resetLogDat = 
function () {
    try{
    //ޤܤ
    this.extractNone();
    this.refuge();
    this.clear();
    
    for(var i=0; i< this.prevRowSet.length; i++){
       if(this.prevRowSet[i].sureAttr == "NON-DAT"){
            this.prevRowSet[i].sureAttr = "NONDIS";
       }else if(this.prevRowSet[i].sureAttr == "LOG-DAT"){
            this.prevRowSet[i].sureAttr = "LOADED";
       }
       this.sureRowSet.push(this.prevRowSet[i]);
    }
    this.prevRowSet = null;

    this.writeIndex();
    }catch(e){ moz2ch.debug(e); }
};

moz2chIta.prototype.baseDeleteLog = moz2chData.prototype.deleteLog;
moz2chIta.prototype.deleteLog =
function () {
    this.baseDeleteLog();
    this.clear();
};

moz2chIta.prototype.unload = 
function () {
    this.extractNone();
    this.writeIndex();
}

moz2chIta.prototype.destroy =
function () {
    try{
	this.unload();
	delete this.itaID;
	delete this.sureRowSet;
	delete this.prevRowSet;
	delete this.preservedRowSet;
	delete this.logPath;
	delete this.nowSortType;
	delete this.nowSortDirect;
	delete this.title;
	delete this.url;
	delete this.bStream;
	delete this.uri;
	delete this.iStream;
	delete this.channel;
	delete this.bbsId;
	delete this.bbsFir;
	delete this.sabaID;
	delete this.logPath;
	delete this.indexPath;
	delete this.data;
    delete this.oldData
	delete this.itadata;
	delete this.itaoldData;
	delete this.data;
	delete this.moz2chDir;
    }catch(e){ moz2ch.debug(e); }
}

//ͥåȥطƼץ
moz2chIta.prototype.stop =
function () {
    if (this.itachannel && this.itachannel.isPending()) {
        moz2ch.debug("moz2chIta.stop: stop loading ita " + this.title);
        this.itachannel.cancel(Components.interfaces.nsIRequest.NS_BINDING_ABORTED);
        moz2ch.setBusy(false);
        this.itaoldChannel = this.itachannel;
        this.itachannel = null;
        this.stopFlag = 1;
        this.itadata = this.olditaData;
    }
};

moz2chIta.prototype.get =
function () {
    // initialize data
    this.itaoldData = this.itadata;
    this.itadata = "";

    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                .getService(Components.interfaces.nsIIOService);
    var uri = ioService.newURI(this.getDataURL(), null, null);
    this.itachannel = ioService.newChannelFromURI(uri)
             .QueryInterface(Components.interfaces.nsIHttpChannel);
    // Monazilla UA
    this.itachannel.setRequestHeader("User-Agent", moz2ch.ua, false);
    // load bypass cache(strong reload)
    this.itachannel.loadFlags =
            Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;
    moz2ch.debug("moz2chIta.get: dataURL=" + this.getDataURL());
    moz2ch.debug("moz2chIta.get: loadFlags=" + this.itachannel.loadFlags);
    this.onRequest();
    moz2ch.status(moz2ch.getString("checkdata"));
    // arg 3 is invalid? needs to be reconsidered!
    this.itachannel.asyncOpen(this, this, 0);
};

moz2chIta.prototype.onRequest =
function (channel) {
};

// process by the value of responseStatus
moz2chIta.prototype.onResponse =
function (resStat) {
    switch (resStat) {
    case 200: // OK
        if(this.stopFlag == 1){
            moz2ch.setBusy(false);
            this.stopFlag = 0;
            break;
        }
        this.onGet();
        break;
    default:
        moz2ch.status(moz2ch.getString("onerror"));
        this.onError();
        break;
    }
};

// data handler
moz2chIta.prototype.onGet =
function () {
    try{
        var rv = this.parse();
        this.loaded();
        
        if (rv && this.itadata.length > 0) {
            // if parse succeeded, save the data.
            var f = new File(this.getLogPath());
            f.open("w", kMoz2chDataFilePerm);
            f.write(this.itadata);
            f.close();
        }
    }catch(e){ moz2ch.debug(e); }
};

///////////////////////////////
// implements nsIStreamListener
moz2chIta.prototype.onDataAvailable =
function (request, ctxt, input, offset, count) {
    if (!this.bStream) {
        this.iStream.init(input);
        this.itadata += this.iStream.read(count);
        return;
    }

    /*
        trunkbug 170585fix (ϡ)!!!!
    */
    this.bStream.setInputStream(input);
    var str = this.bStream.readBytes(count);
    str = str.replace(/\x00/g, "*");
    this.itadata += str;
};
    
////////////////////////////////
// implements nsIRequestObserver
moz2chIta.prototype.onStartRequest =
function (request, ctxt) {
};

moz2chIta.prototype.onStopRequest =
function (request, ctxt, status) {
    var resStat;
    try {   // output responseStatus/responseStatusText
        if(this.itaoldChannel){
            //resStat = this.oldChannel.responseStatus;
            //moz2ch.debug(resStat + " " + this.oldChannel.responseStatusText);
            this.oldChannel = null;
            return;
        }else if (this.itachannel){
            resStat = this.itachannel.responseStatus;
            moz2ch.debug(resStat + " " + this.itachannel.responseStatusText);
        }else{
            moz2ch.debug("Stopped by unexpected Error");
        }
    } catch (e) {
        moz2ch.debug(e);
        if (0 != status) {
            // request error! call onError
            moz2ch.debug("requestStatus: " + status);
            this.onError();
            return;
        }
    }
    try {
        this.onResponse(resStat);
    } catch (e) {
        moz2ch.debug("moz2chIta.onStopRequest: " + e);
    }
};
