/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/** 
 * <pre lang="ja">
 * (_(    
 * ( `)   ĥĥ꡼ӥ塼֥ȥʡ
 * (      )     : 2004/05/26
 *      񤤤  : ˼⤸顼
 * (___)__)   Ď؎ˎގ: ĶAnne
 *                      : ؤ41椵
 *                      : (ߢώ)(ߢώ) tRZ80FPU5k
 *            itaTreeɽ˽ʤbugfix
 *            
 * </pre>
 */
moz2chItaTreeView.prototype = new moz2chDataView();

function moz2chItaTreeView () {
}

///////////
// ѿ
moz2chItaTreeView.prototype.elementId = "itaTree";
moz2chItaTreeView.prototype.targetIta = null;

/**
 * ĥĥ꡼ӥ塼ν
 */
moz2chItaTreeView.prototype.baseInit = moz2chDataView.prototype.init;
moz2chItaTreeView.prototype.init =
function () {
    this.baseInit();
}

/**
 * ĥĥ꡼ɤ߹
 * moz2chDataView.loadɤǤޤ
 * RDF˺ݤơľɬפꡣ
 */
moz2chItaTreeView.prototype.load =
function (aData) {
    // if loading, stop it
    this.stop();
    // unload old data
    this.unload();
    
    this.data = aData;
    this.element.database.AddDataSource(this.data.datasource);
    this.update();
    moz2ch.setCurrent(this);
};

/**
 * RDFξ֤ȿǤ
 */
moz2chItaTreeView.prototype.update =
function () {
    this.element.builder.rebuild();
};

/**
 * ĥ꡼Ǥ!
 */
moz2chItaTreeView.prototype.clear =
function () {
    // clear selection
    this.element.treeBoxObject.selection.clearSelection();
};

/**
 * 򤵤Ƥ륢ƥΥƥ
 *
 * @param aRes ץѥƥΥ꥽
 * @return 򤵤Ƥ륢ƥλꤷץѥƥʸ
 */
moz2chItaTreeView.prototype.getSelectedLiteral =
function (aRes) {
    var node = this.data.datasource.GetTarget(
            this.element.builderView.getResourceAtIndex(
            this.element.currentIndex), aRes, true);
    return node
            ? node.QueryInterface(Components.interfaces.nsIRDFLiteral).Value
            : null;
}

/**
 * 򤷤ƥ
 */
moz2chItaTreeView.prototype.loadBySelect =
function () {
    this.selected = true;
    var url = this.getSelectedLiteral(kMoz2chItaTreeURLRes);
    var title = this.getSelectedLiteral(kMoz2chItaTreeTitleRes);
    if (url && !(moz2ch.itaView.data && moz2ch.itaView.data.url == url)) {
        var ita = moz2ch.bbsManager.createIta(this.data.bbsId, this.data, title, url);
	    ita.addDataLoadedListener( moz2ch.itaView );
		var rv = ita.logTest();
		if (rv){
		this.targetIta = null;
        moz2ch.itaView.load(ita);
        moz2ch.itaView.element.mCurrentTree.treeBoxObject.view = moz2ch.itaView;
		}else{
		this.targetIta = ita;
		}
    }
};

/**
 * ֥륯åǥ
 */
moz2chItaTreeView.prototype.reloadByDblClick =
function () {
try{
    this.selected = true;
	if(this.targetIta != null){
        moz2ch.itaView.load(this.targetIta);
        moz2ch.itaView.element.mCurrentTree.treeBoxObject.view = moz2ch.itaView;
		this.targetIta = null;
	}
    var url = this.getSelectedLiteral(kMoz2chItaTreeURLRes);
    if (url && (moz2ch.itaView.data && moz2ch.itaView.data.url == url)) {
        moz2ch.debug("moz2ch.itaTreeView.reloadByDblClick: " + url);
        moz2ch.itaView.reload();
    }
}catch(e) { moz2ch.debug(e); }
};

/**
 * ƥȥ˥塼
 */
moz2chItaTreeView.prototype.reloadByMenuSelect =
function () {
    this.loadBySelect();
	if(this.targetIta != null){
        moz2ch.itaView.load(this.targetIta);
        moz2ch.itaView.element.mCurrentTree.treeBoxObject.view = this;
		this.targetIta = null;
	}
    var url = this.getSelectedLiteral(kMoz2chItaTreeURLRes);
    if (url && (moz2ch.itaView.data && moz2ch.itaView.data.url == url)) {
        moz2ch.debug("moz2ch.itaTreeView.reloadByMenuSelect: " + url);
        moz2ch.itaView.reload();
    }
};

moz2chItaTreeView.prototype.toggle =
function() {
    moz2ch.goToggleToolbar("itatreebox", "showItaTree");
    this.splitterSync();
}

moz2chItaTreeView.prototype.splitterSync =
function() {
    document.getElementById("itaTreeSplitter").setAttribute("hidden",
            document.getElementById("itatreebox").getAttribute("hidden"));
}

moz2chItaTreeView.prototype.createPopup = 
function(aEvent) {
    var popup = document.getElementById("itaTreePopup");
    var url = this.getSelectedLiteral(kMoz2chItaTreeURLRes);

    var popupBuilder = {
        add: function( element, label, handler ) {
              var element = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
                                                  element);
              element.setAttribute("label", label);
              element.setAttribute("oncommand", handler);
              popup.appendChild(element);
              return element;
        },
    }

    for( var i=popup.childNodes.length-1; i >= 0; i-- ) {
          popup.removeChild(popup.childNodes[i]);
    }
    if ( !url ) {
      popupBuilder.add("menuitem", moz2ch.getString("itaTreeAddBookmark"), "moz2ch.debug('uma');");
      popupBuilder.add("menuseparator");
      popupBuilder.add("menuitem", moz2ch.getString("itaTreeAddIta"));
      popupBuilder.add("menuitem", moz2ch.getString("itaTreeAddCategory"));
      popupBuilder.add("menuseparator");
      popupBuilder.add("menuitem", moz2ch.getString("itaTreeRemoveCategory"));

    } else {
      popupBuilder.add("menuitem", moz2ch.getString("itaTreeOpenWithNewTab"), "moz2ch.itaView.element.selectedTab = moz2ch.itaView.element.addTab(); moz2ch.itaTreeView.reloadByMenuSelect();");
      popupBuilder.add("menuitem", moz2ch.getString("itaTreeOpen"), "moz2ch.itaTreeView.reloadByMenuSelect();");
      popupBuilder.add("menuseparator");
      popupBuilder.add("menuitem", moz2ch.getString("itaTreeAddBookmark"));
      popupBuilder.add("menuseparator");
      popupBuilder.add("menuitem", moz2ch.getString("itaTreeCopyURL"), "moz2chClipboard.setText(moz2ch.itaTreeView.getSelectedLiteral(kMoz2chItaTreeURLRes));");
      popupBuilder.add("menuitem", moz2ch.getString("itaTreeCopyTitle"), "moz2chClipboard.setText(moz2ch.itaTreeView.getSelectedLiteral(kMoz2chItaTreeTitleRes));");
      popupBuilder.add("menuseparator");
      popupBuilder.add("menuitem", moz2ch.getString("itaTreeRemoveIta"));
    }
};

//tree elementrefꤹ
moz2chItaTreeView.prototype.setRDFRootURI = 
function (uri) {
    this.element.setAttribute("ref", uri);
};

moz2chItaTreeView.prototype.addBBSMenuItem = 
function ( label, value ) {
    var mlist = document.getElementById("bbsList");
    var mitem = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
                                             "menuitem");
    mitem.setAttribute("label", label);
    mitem.setAttribute("value", value);
    mlist.menupopup.appendChild(mitem); 
};


/////////////////////////////////////////////
// ͎ގݎĎʎݎĎގ׎(ߢώ)!!!!
function moz2chItaTreeFocus() {
    if (!moz2chItaTreeView.selected)
        moz2ch.setCurrent(moz2chItaTreeView);
}
function moz2chItaTreeBlur() {
    moz2ch.itaTreeView.selected = false;
}

function moz2chItaTreeSelect() {
    if(moz2ch.itaTreeView.timerId)
	clearTimeout(moz2ch.itaTreeView.timerId);
    moz2ch.itaTreeView.loadBySelect();
}

function moz2chItaTreeReload() {
    moz2ch.itaTreeView.reload();
}
function moz2chItaTreeLoad(aEvent) {
    moz2ch.itaTreeView.init();
}

function moz2chItaTreeClick( aEvent ) {
    try {
	moz2ch.itaView.saveCurSurePos();
        var row = {};
        var col = {};
        var obj = {};
        moz2ch.itaTreeView.element.treeBoxObject.getCellAt(aEvent.clientX, aEvent.clientY, row, col, obj);
        row = row.value;

        if ( (row >= 0) && col && (obj.value == "text" || obj.value == "cell") ) {
            if ( 0 == aEvent.button ) {
                if ( 1 == aEvent.detail ) {
                    moz2ch.itaTreeView.timerId = setTimeout(moz2chItaTreeSelect, 50);
                } else if ( 2 == aEvent.detail ) {
		    if(moz2ch.itaTreeView.timerId){
			clearTimeout(moz2ch.itaTreeView.timerId);
			moz2chItaTreeSelect();
		    }
                    moz2ch.itaTreeView.reloadByDblClick();
                }
            } else if ( 2 == aEvent.button ) {
                    //moz2ch.debug("popup");
            }
        }
    } catch (e) {
        moz2ch.debug( "moz2chItaTreeClick Error " + e );
    }
};

addEventListener("load", moz2chItaTreeLoad, false);
