/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ĤΥ롼ʡ
 * (      )     : 2003/07/30
 *      񤤤  : ؤ41
 * (___)__)   Ď؎ˎގ: 
 *            
 *
 * </pre>
 */

include("chrome://moz2ch/content/data.js");


const kMoz2chLocalRuleLeaf = "head.txt";

function moz2chLocalRule ( ita ) {
    this.ita = ita;
}

/////////////////////
// extends moz2chData
moz2chLocalRule.prototype = new moz2chData();

moz2chLocalRule.prototype.logPath = null;
moz2chLocalRule.prototype.getLogPath =
function () {
    if (!this.logPath) {
        var logFile = new Dir(this.getMoz2chDir());
        var sabaIDs = this.ita.sabaID.split("/");
        for (var i = 0; i < sabaIDs.length; i++) {
            logFile.append(sabaIDs[i]);
            if (!logFile.exists())
                logFile.create(kMoz2chDataDirPerm);
        }
        logFile.append(this.ita.itaID);
        if (!logFile.exists())
            logFile.create(kMoz2chDataDirPerm);
        logFile.append(kMoz2chLocalRuleLeaf);
        this.logPath = logFile.path;
    }
    return this.logPath;
};

moz2chLocalRule.prototype.getDataURL =
function () {
    return this.ita.url + kMoz2chLocalRuleLeaf;
};

/////////////////
// parse the data
moz2chLocalRule.prototype.parse =
function () {
    try{
    var data = this.data;
    var browser = document.getElementById("localRuleBrowser");
    var doc = browser.contentDocument;
    
    var range = doc.createRange();
    var body = doc.getElementsByTagName("body")[0];
    var childs = body.childNodes;
    for(var i=(childs.length-1); i>=0; i--){
	if(childs[i].nodeType != 3){
	    body.removeChild(childs[i]);
	}
    }
    range.selectNodeContents(body);
    range.collapse(true);
    
    var cf = range.createContextualFragment(moz2chCharset.sjis2uni(data));

    body.appendChild(cf);
    }catch(e){ moz2ch.debug(e); }
};

